function [Zpred,rate,I]=miscler(...
type,flag,q,X,Xf,Zf,Y,GammaD,dbar, PostGamD,naver,Hg)

%miscler: Bayesian Variable Selection
%         Prediction by Least Squares, Bayesian Model Averaging
%
%Copyright (c) 1997-2003 Marina Vannucci and Naijun Sha.
%**********************************************************************


[nOssf,colt]=size(Zf);

switch flag
case 'LS'
	[YP,I]=predico('LS',X,Y,Xf,GammaD);
case 'BMA'
	[YP,I]=predico('BMA',X,Y,Xf,GammaD,PostGamD,Hg,naver);
end

Zpred=zeros(nOssf,1);
if type==0
	switch q
   	case 1
      		Zpred(find(YP<0))=0;Zpred(find(YP>0))=1;
   	otherwise
      		YPt=YP';maxyp=max(YPt);
      		nagind=find(maxyp<0);
      		posind=find(maxyp>=0);
      		Zpred(nagind)=0;poslen=length(posind);
      		for j=1:poslen
          		loc=posind(j);
          		[maxval,ind]=max(YP(loc,:));
          		Zpred(loc)=ind;
      		end
	end
else	
	for j=1:length(dbar)-1
		Zpred(find(dbar(j)<YP & YP<=dbar(j+1)))=j-1;
	end
end
rate=1-sum(Zf==Zpred)/nOssf;
