function Y=multruncnord(mu,S,dpar,Y,Z)

% multruncnord: Bayesian Variable Selection
%       Sampling from truncated normal - ordinal response case.
%
%Copyright (c) 2003 Naijun Sha.
%**********************************************************************


n=size(Z,1);
for i=1:n
   Y2=Y;Y2(i)=[];
   mu1=mu(i);mu2=mu;mu2(i)=[];
   S11=S(i,i);S12=S(i,:);S12(:,i)=[];S21=S12';
   S22=S;S22(i,:)=[];S22(:,i)=[];S22inv=inv(S22);
   S112=S11-S12*S22inv*S21;
   s=sqrt(S112);
   m1=mu1+S12*S22inv*(Y2-mu2);
   z=Z(i);      
   d1=dpar(z+1);d2=dpar(z+2);
   p1=normcdf(d1,m1,s);p2=normcdf(d2,m1,s);
   u=rand(1);
   y=norminv(u*p2+(1-u)*p1,m1,s);
Y(i)=y;
end;

