function T=multrunct(d,P,Q,T,mu,z)

% multrunct: Bayesian Variable Selection
%       Sampling from truncated t 
%       based on class label Z,
%       with mean vector mu and covariance matrix P and Q
%       Nominal response case.
%
%Copyright (c) 2003 Naijun Sha.
%**********************************************************************


q=size(T,2);dnew=d+q-1;
for i=1:q
    P11=P(i,i);P12=delsamps(P(i,:)',i)';P21=P12';
    P22=delsamps(P,i);P22=delsamps(P22',i)';P22inv=inv(P22);
    P112=P11-P12*P22inv*P21;T2=delsamps(T',i);
    mstar=P12*P22inv*T2;Qnew=Q+T2'*P22inv*T2;
    m=mu(i);c=sqrt(P112*Qnew/dnew);
    if z==0
       cut=-(m+mstar)/c;p=tcdf(cut,dnew);u=rand(1);
       t1=tinv(u*p,dnew);if t1==-Inf t1=-100;end;
       T(i)=mstar+c*t1;
    else
       if z==i
          mu2=delsamps(mu',i);y2=max(T2+mu2);
          c1=-(m+mstar)/c;c2=(y2-m-mstar)/c;cut=max(c1,c2);
          p=tcdf(cut,dnew);u=rand(1);
          t1=tinv(u*(1-p)+p,dnew);if t1==Inf t1=100;end;
          T(i)=mstar+c*t1;
       else
          yz=T(z)+mu(z);cut=(yz-m-mstar)/c;
          p=tcdf(cut,dnew);u=rand(1);
          t1=tinv(u*p,dnew);if t1==-Inf t1=-100;end;
          T(i)=mstar+c*t1;
       end;
    end;
 end;
   








